'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactVirtualized = require('react-virtualized');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _utils = require('../utils');

var _Month = require('../Month');

var _Month2 = _interopRequireDefault(_Month);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var style = {
	'root': 'Cal__List__root',
	'scrolling': 'Cal__List__scrolling'
};

var List = function (_Component) {
	_inherits(List, _Component);

	function List(_ref) {
		var months = _ref.months;

		_classCallCheck(this, List);

		var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(List).call(this));

		_initialiseProps.call(_this);

		_this.monthMap = months.map(function (month) {
			return month.date.format('YYYYMM');
		});
		_this.rowHeights = months.map(function (month) {
			return month.height;
		});
		return _this;
	}

	_createClass(List, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			var vs = this.refs.VirtualScroll;
			var grid = vs && vs.refs.Grid;

			this.scrollEl = grid && grid.refs.scrollingContainer;
		}

		// 	scrollView.removeEventListener('transitionend', onTransitionEnd);
		// }

		// window.requestAnimationFrame(() => {
		// 	scrollView.style.transform = `translate3d(0,${delta}px,0)`;
		// 	scrollView.style.transition = 'transform 0.4s ease';
		//
		// 	scrollView.addEventListener('transitionend', onTransitionEnd);
		// });

	}, {
		key: 'render',
		value: function render() {
			var _props = this.props;
			var height = _props.height;
			var isScrolling = _props.isScrolling;
			var onScroll = _props.onScroll;
			var overscanMonthCount = _props.overscanMonthCount;
			var months = _props.months;
			var rowHeight = _props.rowHeight;
			var selectedDate = _props.selectedDate;
			var today = _props.today;
			var width = _props.width;

			if (!this.initScrollTop) this.initScrollTop = this.getDateOffset(selectedDate && selectedDate.date || today.date);
			if (typeof width == 'string' && width.indexOf('%') !== -1) {
				width = window.innerWidth * parseInt(width.replace('%', ''), 10) / 100; // See https://github.com/bvaughn/react-virtualized/issues/229
			}

			return _react2.default.createElement(_reactVirtualized.VirtualScroll, {
				ref: 'VirtualScroll',
				width: width,
				height: height,
				rowCount: months.length,
				rowHeight: this.getRowHeight,
				rowRenderer: this.renderMonth,
				onScroll: onScroll,
				scrollTop: this.initScrollTop,
				className: (0, _classnames2.default)(style.root, _defineProperty({}, style.scrolling, isScrolling)),
				style: { lineHeight: rowHeight + 'px' },
				overscanRowCount: overscanMonthCount
			});
		}
	}]);

	return List;
}(_react.Component);

List.propTypes = {
	width: _react.PropTypes.oneOfType([_react.PropTypes.number, _react.PropTypes.string]),
	height: _react.PropTypes.number,
	rowHeight: _react.PropTypes.number,
	selectedDate: _react.PropTypes.object,
	disabledDates: _react.PropTypes.arrayOf(_react.PropTypes.string),
	disabledDays: _react.PropTypes.arrayOf(_react.PropTypes.number),
	months: _react.PropTypes.arrayOf(_react.PropTypes.object),
	onDaySelect: _react.PropTypes.func,
	onScroll: _react.PropTypes.func,
	overscanMonthCount: _react.PropTypes.number,
	isScrolling: _react.PropTypes.bool,
	today: _utils.validParsedDate,
	minDate: _utils.validParsedDate,
	maxDate: _utils.validParsedDate,
	showOverlay: _react.PropTypes.bool,
	theme: _react.PropTypes.object,
	locale: _react.PropTypes.object
};

var _initialiseProps = function _initialiseProps() {
	var _this2 = this;

	this.getRowHeight = function (_ref2) {
		var index = _ref2.index;

		return _this2.props.months[index].height;
	};

	this.getMonthIndex = function (date) {
		var index = _this2.monthMap.indexOf((0, _moment2.default)(date).format('YYYYMM'));

		return index;
	};

	this.getDateOffset = function (date) {
		var index = _this2.getMonthIndex(date);
		var rowHeights = _this2.rowHeights.slice(0, index);
		var offsetTop = rowHeights.reduce(function (a, b) {
			return a + b;
		}, 0);

		return offsetTop;
	};

	this.scrollToDate = function (date) {
		var offset = arguments.length <= 1 || arguments[1] === undefined ? 0 : arguments[1];

		if (_this2.scrollEl) {
			var offsetTop = _this2.getDateOffset(date);
			_this2.scrollTo(offsetTop + offset);
		}
	};

	this.scrollTo = function () {
		var offset = arguments.length <= 0 || arguments[0] === undefined ? 0 : arguments[0];
		var scrollEl = _this2.scrollEl;


		if (scrollEl) {
			// let scrollView = scrollEl.children[0];
			// let currentScrollTop = scrollEl.scrollTop;
			// let delta = -(offset - currentScrollTop);

			// function onTransitionEnd () {
			// 	scrollView.style.transform = 'translate3d(0,0,0)';
			// 	scrollView.style.transition = '';
			scrollEl.scrollTop = offset;
		}
	};

	this.renderMonth = function (_ref3) {
		var index = _ref3.index;
		var isScrolling = _ref3.isScrolling;
		var _props2 = _this2.props;
		var disabledDates = _props2.disabledDates;
		var disabledDays = _props2.disabledDays;
		var locale = _props2.locale;
		var maxDate = _props2.maxDate;
		var minDate = _props2.minDate;
		var months = _props2.months;
		var onDaySelect = _props2.onDaySelect;
		var rowHeight = _props2.rowHeight;
		var selectedDate = _props2.selectedDate;
		var showOverlay = _props2.showOverlay;
		var theme = _props2.theme;
		var today = _props2.today;
		var _months$index = months[index];
		var date = _months$index.date;
		var rows = _months$index.rows;


		return _react2.default.createElement(_Month2.default, {
			key: 'Month-' + index,
			selectedDate: selectedDate,
			displayDate: date,
			disabledDates: disabledDates,
			disabledDays: disabledDays,
			maxDate: maxDate,
			minDate: minDate,
			onDaySelect: onDaySelect,
			rows: rows,
			rowHeight: rowHeight,
			isScrolling: isScrolling,
			showOverlay: showOverlay,
			today: today,
			theme: theme,
			locale: locale
		});
	};
};

exports.default = List;