import { getDaysInMonth, getMonthsForYear } from '../utils';

export default function Year(_ref) {
	var min = _ref.min;
	var max = _ref.max;
	var year = _ref.year;
	var rowHeight = _ref.rowHeight;

	return getMonthsForYear(year, min, max).map(function (monthDate) {
		var rows = {};
		var daysInMonth = getDaysInMonth(monthDate);

		var week = void 0,
		    date = void 0,
		    lastWeekVal = void 0;
		var weekIndex = -1;

		for (var i = 0, len = daysInMonth.length; i < len; i++) {
			date = daysInMonth[i];
			week = date.week();

			if (week !== lastWeekVal) {
				lastWeekVal = week;
				weekIndex++;
			}

			if (!rows[weekIndex]) {
				rows[weekIndex] = [];
			}

			rows[weekIndex].push({
				date: date,
				yyyymmdd: date.format('YYYYMMDD')
			});
		}

		rows = Object.keys(rows).map(function (row) {
			return rows[row];
		});
		var lastWeek = rows[rows.length - 1];
		var height = rows.length >= 6 || rows.length >= 5 && lastWeek.length === 7 ? rowHeight * 5 : rowHeight * 4;

		return {
			date: date,
			rows: rows,
			height: height
		};
	});
}